%global _without_cdio	1
%global _without_vaapi	1
%global _without_openal	1
%global _without_pulse	1
%global _without_x264	1
%global _without_celt     1
%global _without_frei0r   1
%global _without_opencv   1
%global _without_vpx      1

Summary:        Digital VCR and streaming server
Name:           ffmpeg
Version:        2.2.3
Release:        b1%{?date}%{?date:git}%{?rel}%{?dist}
%if 0%{?_with_amr:1}
License:        GPLv3+
%else
License:        GPLv2+
%endif
URL:            http://ffmpeg.org/
%if 0%{?date}
Source0:        ffmpeg-%{?branch}%{date}.tar.bz2
%else
Source0:        http://ffmpeg.org/releases/ffmpeg-%{version}.tar.bz2
%endif
BuildRequires:  bzip2-devel
%{!?_without_celt:BuildRequires: celt-devel}
%{?_with_dirac:BuildRequires: dirac-devel}
%{?_with_faac:BuildRequires: faac-devel}
BuildRequires:  freetype-devel
%{!?_without_frei0r:BuildRequires: frei0r-devel}
#BuildRequires:  gnutls-devel
#BuildRequires:  gsm-devel
#BuildRequires:  lame-devel >= 3.98.3
%{?_with_jack:BuildRequires: jack-audio-connection-kit-devel}
#BuildRequires:  libass-devel
%{!?_without_cdio:BuildRequires: libcdio-paranoia-devel}
#libcrystalhd is currently broken
%{?_with_crystalhd:BuildRequires: libcrystalhd-devel}
#BuildRequires:  libdc1394-devel
#Buildrequires:  libmodplug-devel
%{?_with_rtmp:BuildRequires: librtmp-devel}
#BuildRequires:  libtheora-devel
#BuildRequires:  libv4l-devel
#BuildRequires:  libvdpau-devel
#BuildRequires:  libvorbis-devel
%{?!_without_vpx:BuildRequires: libvpx-devel >= 0.9.1}
%ifarch %{ix86} x86_64
#BuildRequires:  libXvMC-devel
%{?!_without_vaapi:BuildRequires: libva-devel >= 0.31.0}
%endif
%{?_with_amr:BuildRequires: opencore-amr-devel vo-amrwbenc-devel}
%{!?_without_openal:BuildRequires: openal-soft-devel}
%{!?_without_opencv:BuildRequires: opencv-devel}
#BuildRequires:  openjpeg-devel
#BuildRequires:  opus-devel
%{!?_without_pulse:BuildRequires: pulseaudio-libs-devel}
#BuildRequires:  perl(Pod::Man)
#BuildRequires:  schroedinger-devel
BuildRequires:  SDL-devel
#BuildRequires:  soxr-devel
#BuildRequires:  speex-devel
#BuildRequires:  subversion
#BuildRequires:  texi2html
%{!?_without_x264:BuildRequires: x264-devel >= 0.0.0-0.31}
#BuildRequires:  xvidcore-devel
BuildRequires:  zlib-devel
%ifarch %{ix86} x86_64
BuildRequires:  yasm
%endif

%description
FFmpeg is a complete and free Internet live audio and video
broadcasting solution for Linux/Unix. It also includes a digital
VCR. It can encode in real time in many formats including MPEG1 audio
and video, MPEG4, h263, ac3, asf, avi, real, mjpeg, and flash.

%package        devel
Summary:        Development package for %{name}
Requires:       pkgconfig

%description    devel
FFmpeg is a complete and free Internet live audio and video
broadcasting solution for Linux/Unix. It also includes a digital
VCR. It can encode in real time in many formats including MPEG1 audio
and video, MPEG4, h263, ac3, asf, avi, real, mjpeg, and flash.
This package contains development files for %{name}

%global ff_configure \
../configure \\\
    --prefix=%{_prefix} \\\
    --bindir=%{_bindir} \\\
    --datadir=%{_datadir}/%{name} \\\
    --incdir=%{_includedir}/%{name} \\\
    --libdir=%{_libdir} \\\
    --mandir=%{_mandir} \\\
    --arch=%{_target_cpu} \\\
    --optflags="$RPM_OPT_FLAGS" \\\
    %{?_with_amr:--enable-libopencore-amrnb --enable-libopencore-amrwb --enable-libvo-amrwbenc --enable-version3} \\\
    --enable-bzlib \\\
    %{!?_with_crystalhd:--disable-crystalhd} \\\
    %{!?_without_frei0r:--enable-frei0r} \\\
    %{!?_without_cdio:--enable-libcdio} \\\
    %{!?_without_celt:--enable-libcelt} \\\
    %{?_with_dirac:--enable-libdirac} \\\
    %{?_with_faac:--enable-libfaac --enable-nonfree} \\\
    %{!?_with_jack:--disable-indev=jack} \\\
    --enable-libfreetype \\\
    %{!?_without_openal:--enable-openal} \\\
    %{!?_without_opencv:--enable-libopencv} \\\
    %{!?_without_pulse:--enable-libpulse} \\\
    %{?_with_rtmp:--enable-librtmp} \\\
    %{!?_without_vpx:--enable-libvpx} \\\
    %{!?_without_x264:--enable-libx264} \\\
    --enable-x11grab \\\
    --enable-avfilter \\\
    --enable-avresample \\\
    --enable-postproc \\\
    --enable-pthreads \\\
    --disable-static \\\
    --enable-shared \\\
    --enable-gpl \\\
    --disable-debug


%prep
%if 0%{?date}
%setup -q -n ffmpeg-%{?branch}%{date}
echo "git-snapshot-%{?branch}%{date}-RPMFusion" > VERSION
%else
%setup -q -n ffmpeg-%{version}
%endif
# fix -O3 -g in host_cflags
sed -i "s/-O3 -g/$RPM_OPT_FLAGS/" configure

%build
mkdir generic
pushd generic
%{ff_configure}\
    --shlibdir=%{_libdir} \
%if 0%{?ffmpegsuffix:1}
    --build-suffix=%{ffmpegsuffix} \
    --disable-doc \
    --disable-ffmpeg --disable-ffplay --disable-ffprobe --disable-ffserver \
%else
%ifarch %{ix86}
    --cpu=%{_target_cpu} \
%endif
%ifarch %{ix86} x86_64
    --enable-runtime-cpudetect \
%endif
%ifarch ppc
    --cpu=g3 \
    --enable-runtime-cpudetect \
    --enable-pic \
%endif
%ifarch ppc64
    --cpu=g5 \
    --enable-runtime-cpudetect \
    --enable-pic \
%endif
%ifarch sparc sparc64
    --disable-vis \
%endif
%ifarch %{arm}
    --disable-runtime-cpudetect --arch=arm \
%ifarch armv6hl
    --cpu=armv6 \
%else
    --enable-thumb \
%endif
%ifarch armv7hnl
    --enable-neon \
%endif
%endif
%endif

make %{?_smp_mflags} V=1
make documentation V=1
make alltools V=1
popd

%if 0%{!?ffmpegsuffix:1}
mkdir simd
pushd simd
%ifarch sparc sparc64
%{ff_configure}\
    --shlibdir=%{_libdir}/v9 \
    --cpu=v9 \
    --enable-vis \
    --disable-ffmpeg \
    --disable-ffserver \
    --disable-ffplay \

make %{?_smp_mflags} V=1
%endif
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT
pushd generic
make install DESTDIR=$RPM_BUILD_ROOT V=1
popd
%if 0%{!?ffmpegsuffix:1}
install -pm755 generic/tools/qt-faststart $RPM_BUILD_ROOT%{_bindir}
pushd simd
%ifarch sparc sparc64
make install DESTDIR=$RPM_BUILD_ROOT V=1
%endif
popd
%endif

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%if 0%{!?ffmpegsuffix:1}
%files
#%doc COPYING.* CREDITS README doc/ffserver.conf
%{_bindir}/ffmpeg
%{_bindir}/ffplay
%{_bindir}/ffprobe
%{_bindir}/ffserver
%{_bindir}/qt-faststart
#%{_mandir}/man1/ffmpeg*.1*
#%{_mandir}/man1/ffplay*.1*
#%{_mandir}/man1/ffprobe*.1*
#%{_mandir}/man1/ffserver*.1*
%{_datadir}/ffmpeg
%endif

%{_libdir}/lib*.so.*
#%{_mandir}/man3/lib*.3.gz
%if 0%{!?ffmpegsuffix:1}
%ifarch sparc sparc64
%{_libdir}/v9/lib*.so.*
%endif
%endif

%files devel
%doc MAINTAINERS doc/APIchanges doc/*.txt
%{_includedir}/ffmpeg
%{_libdir}/pkgconfig/lib*.pc
%{_libdir}/lib*.so
%if 0%{!?ffmpegsuffix:1}
%ifarch sparc sparc64
%{_libdir}/v9/lib*.so
%endif
%endif


%changelog
* Tue Jun 10 2014 Yuichiro Nakada <berry@berry-lab.net>
- Update to 2.2.3
* Mon Oct 11 2010 Yuichiro Nakada <berry@rberry.co.cc>
- Create for Berry Linux
